
function FlexBar2:GetStandardMiscHeaderAttribs()
	return {
	-- set statebutton in the header and have the button pull data from here...
		{"statebutton","0:normal"},
	-- Set the current state
		{"state","0"},
	}
end

function FlexBar2:GetStandardRogueHeaderAttribs()
	return {
		{"statemap-stealth-0","0"}, -- Unstealthed
		{"statemap-stealth-1","1"}, -- Stealthed
	-- set statebutton in the header and have the button pull data from here...
		{"statebutton","0:normal;1:stealth"},
	-- Set the current state
		{"state",tostring(GetShapeshiftForm(true))},
	}
end

function FlexBar2:GetStandardWarriorHeaderAttribs()
	return {
		{"statemap-stance-1","0"}, -- Battle -- is the Warrior normal stance
		{"statemap-stance-2","2"}, -- Defense -- This may be Berserker stance on a Warrior without Defense stance... but that shouldn't be a problem in practice
		{"statemap-stance-3","3"}, -- Berserker
	-- set statebutton in the header and have the button pull data from here...
		{"statebutton","0:normal;2:defense;3:berserk"},
	-- Set the current state
		{"state",tostring(GetShapeshiftForm(true))},
	}
end

function FlexBar2:GetStandardDruidHeaderAttribs(header)
	-- TODO Actually Verify all of this and ensure that the statebutton contents for Druids below is accurate.
	return {
		{"statemap-stance-0","0"}, -- Normal
		{"statemap-stance-1","4"}, -- Bear/ Dire Bear
		{"statemap-stance-2","5"}, -- Aquatic
		{"statemap-stance-3","6"}, -- Cat
		{"statemap-stance-4","7"}, -- Travel
		{"statemap-stance-5","8"}, -- Moonkin Form
		{"statemap-stance-6","9"}, -- Not 100% sure about these... will need a high level druid to test this stuff...
		{"statemap-stance-7","10"},
	-- the following makes sure that losing stealth only changes the bar if you remained in cat form, otherwise the other stance stuff takes effect.
		{"statemap-stealth-0","1:6"}, -- prowl (1) to cat (6)
		{"statemap-stealth-1","6:1"}, -- cat to prowl
	-- set the header's active state upon creation.
	-- TODO Set the header state for druids appropriately.
	-- set statebutton in the header and have the button pull data from here...
		{"statebutton","0:normal;1:stealth;4:bear;5:aquatic;6:cat;7:travel;8:moonkin"},
	}
end

-- call this like: FlexBar2.Group.Handlers.SetStanceHeaderByClass(GroupName,[true])
FlexBar2.Group:RegisterHandler("SetStanceHeaderByClass",function(self,Save)
	local groupName = self
	if type(self) == "table" then
		if self.Group then
			groupName = self.Group.name
		else
			groupName = self.name
		end
	end
	local class = select(2,UnitClass("player"))
	if class == "DRUID" then
		FlexBar2.Group:DefineSecureHeader(groupName,"SecureStateDriverTemplate",FlexBar2:GetStandardDruidHeaderAttribs())
	elseif class == "ROGUE" then
		FlexBar2.Group:DefineSecureHeader(groupName,"SecureStateDriverTemplate",FlexBar2:GetStandardRogueHeaderAttribs())
	elseif class == "WARRIOR" then
		FlexBar2.Group:DefineSecureHeader(groupName,"SecureStateDriverTemplate",FlexBar2:GetStandardWarriorHeaderAttribs())
	else
		FlexBar2.Group:DefineSecureHeader(groupName,"SecureStateDriverTemplate",FlexBar2:GetStandardMiscHeaderAttribs())
	end
	if Save then
		FlexBar2.db.profile.Groups[groupName].autoHandler = FlexBar2.db.profile.Groups[groupName].autoHandler or {}
		table.insert(FlexBar2.db.profile.Groups[groupName].autoHandler,"SetStanceHeaderByClass")
	end
end)

local Mapping = FlexBar2.OO.Mixin 
{
	"SetNormalMap",
	"SetStanceMap",
};

function Mapping:SetNormalMap(modifier,msButton,bType,id,Save)
	modifier = modifier or ""
	msButton = msButton or ""
	bType = bType or "action"
	local attr = modifier..bType..msButton
	local value = id
	self:SetAttribute("type",bType,Save)
	self:SetAttribute(attr,value,Save)
end

function Mapping:SetStanceMap(modifier,msButton,stance,bType,id,Save)
	modifier = modifier or ""
	msButton = msButton or ""
	stance = stance or "normal"
	bType = bType or "action"
	local attr = modifier..bType..msButton.."-"..stance
	local value = id
	self:SetAttribute("type",bType,Save)
	self:SetAttribute(attr,value,Save)
end

FlexBar2:RegisterHandler(Mapping);
