local Tooltips = FlexBar2.OO.Mixin 
{
	"ShowTooltip",
	"HideTooltip",
	"UpdateTooltip",
};


function Tooltips:Activate()
	self:RegisterScript("OnEnter","ShowTooltip")
	self:RegisterScript("OnLeave","HideTooltip")
	self:RegisterEvent("FB2_UPDATE","UpdateTooltip")
end

function Tooltips:ShowTooltip()
	local Frame = self.Frame
	if ( GetCVar("UberTooltips") == "1" ) then
		GameTooltip_SetDefaultAnchor(GameTooltip, Frame)
	else
		GameTooltip:SetOwner(Frame, "ANCHOR_RIGHT")
	end
	
	if ( GameTooltip:SetAction(self:GetEffectiveAttribute("action")) ) then
		self.updateTooltip = true
	else
		self.updateTooltip = nil
	end
end

function Tooltips:HideTooltip()
	self.updateTooltip = nil
	GameTooltip:Hide()
end

function Tooltips:UpdateTooltip()
	if not self.updateTooltip then return end

	if ( GameTooltip:IsOwned(self.Frame) ) then
		self:ShowTooltip()
	else
		self.updateTooltip = nil
	end
end

FlexBar2:RegisterHandler(Tooltips);
